﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WPF.Framework.Models.Repository.Base
{
    public abstract class IRepository<T> where T: class, IEntity
    {
        public abstract IQueryable<T> Items { get; }
        public abstract T Get(int id);
        public abstract void Remove(int id);
        public abstract void Update(T entity);
        public abstract T Add(T entity);
    }
}
